# Generated by ariadne-codegen
# Source: ../graphql

from typing import Any, AsyncIterator, Dict, List, Optional, Union

from .abort_execution import AbortExecution
from .add_api_key import AddApiKey
from .add_role import AddRole
from .add_role_device_group import AddRoleDeviceGroup
from .add_role_neops_task import AddRoleNeopsTask
from .add_user import AddUser
from .add_users_to_role import AddUsersToRole
from .archive_or_delete_task import ArchiveOrDeleteTask
from .async_base_client import AsyncBaseClient
from .autocomplete_fields import AutocompleteFields
from .base_model import UNSET, UnsetType
from .client_aggregation import ClientAggregation
from .client_result import ClientResult
from .clients import Clients
from .cron_execution_type import CronExecutionType
from .device_aggregation import DeviceAggregation
from .device_group_elastic import DeviceGroupElastic
from .device_group_result import DeviceGroupResult
from .device_group_upsert import DeviceGroupUpsert
from .device_result import DeviceResult
from .device_upsert import DeviceUpsert
from .devices import Devices
from .discovery import Discovery
from .enums import (
    CronExecuteTypeEnum,
    ExecutionTypeEnum,
    OutputSchemaTypeEnum,
    ProviderSchemaEnum,
    RunOnEnum,
)
from .execute_neops_task import ExecuteNeopsTask
from .execution import Execution
from .execution_subscription import ExecutionSubscription
from .executions import Executions
from .executions_elastic import ExecutionsElastic
from .get_role import GetRole
from .group_aggregation import GroupAggregation
from .interface_aggregation import InterfaceAggregation
from .interface_result import InterfaceResult
from .interfaces import Interfaces
from .json_form import JsonForm
from .location_upsert import LocationUpsert
from .login import Login
from .neops_provider import NeopsProvider
from .neops_task_create_mutation import NeopsTaskCreateMutation
from .neops_task_unarchive import NeopsTaskUnarchive
from .neops_tasks import NeopsTasks
from .permissions import Permissions
from .platforms import Platforms
from .process_overview import ProcessOverview
from .providers import Providers
from .refresh_token import RefreshToken
from .reports import Reports
from .reports_execute import ReportsExecute
from .role_device_group import RoleDeviceGroup
from .role_device_group_upsert import RoleDeviceGroupUpsert
from .role_neops_task import RoleNeopsTask
from .role_neops_task_upsert import RoleNeopsTaskUpsert
from .role_permission_element import RolePermissionElement
from .role_permission_element_upsert import RolePermissionElementUpsert
from .role_permission_upsert import RolePermissionUpsert
from .role_permissions import RolePermissions
from .role_scope_upsert import RoleScopeUpsert
from .role_user import RoleUser
from .rollback import Rollback
from .saved_search_create import SavedSearchCreate
from .saved_search_delete import SavedSearchDelete
from .saved_searches import SavedSearches
from .scope_delete import ScopeDelete
from .scopes import Scopes
from .scopes_upsert import ScopesUpsert
from .single_discovery import SingleDiscovery
from .topology import Topology


def gql(q: str) -> str:
    return q


class Client(AsyncBaseClient):
    async def abort_execution(
        self,
        id: Union[Optional[int], UnsetType] = UNSET,
        task_id: Union[Optional[str], UnsetType] = UNSET,
        **kwargs: Any
    ) -> AbortExecution:
        _query = gql(
            """
            mutation abortExecution($id: Int, $taskId: String) {
              abortExecution(id: $id, taskId: $taskId) {
                executions {
                  id
                  name
                  state
                  neopsTask {
                    id
                    name
                  }
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {"id": id, "taskId": task_id}
        _response = await self.execute(
            query=_query,
            operation_name="abortExecution",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return AbortExecution.model_validate(_data)

    async def add_api_key(
        self,
        app: str,
        description: Union[Optional[str], UnsetType] = UNSET,
        user_id: Union[Optional[str], UnsetType] = UNSET,
        **kwargs: Any
    ) -> AddApiKey:
        _query = gql(
            """
            mutation addApiKey($app: String!, $description: String, $userId: ID) {
              staticApiKeyCreate(app: $app, description: $description, userId: $userId) {
                app
                accessToken
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "app": app,
            "description": description,
            "userId": user_id,
        }
        _response = await self.execute(
            query=_query, operation_name="addApiKey", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return AddApiKey.model_validate(_data)

    async def add_role(
        self,
        name: Union[Optional[str], UnsetType] = UNSET,
        users: Union[Optional[List[Optional[str]]], UnsetType] = UNSET,
        **kwargs: Any
    ) -> AddRole:
        _query = gql(
            """
            mutation addRole($name: String, $users: [ID]) {
              roleUpsert(name: $name, users: $users) {
                role {
                  id
                  users {
                    id
                    username
                  }
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {"name": name, "users": users}
        _response = await self.execute(
            query=_query, operation_name="addRole", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return AddRole.model_validate(_data)

    async def add_role_device_group(
        self,
        device_group_id: Union[Optional[str], UnsetType] = UNSET,
        role_id: Union[Optional[str], UnsetType] = UNSET,
        permission: Union[Optional[int], UnsetType] = UNSET,
        **kwargs: Any
    ) -> AddRoleDeviceGroup:
        _query = gql(
            """
            mutation addRoleDeviceGroup($deviceGroupId: ID, $roleId: ID, $permission: Int) {
              roleDeviceGroupUpsert(
                deviceGroupId: $deviceGroupId
                roleId: $roleId
                permission: $permission
              ) {
                roleDeviceGroup {
                  role {
                    id
                    users {
                      id
                      username
                    }
                  }
                  deviceGroup {
                    id
                    name
                    devices {
                      hostname
                    }
                  }
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "deviceGroupId": device_group_id,
            "roleId": role_id,
            "permission": permission,
        }
        _response = await self.execute(
            query=_query,
            operation_name="addRoleDeviceGroup",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return AddRoleDeviceGroup.model_validate(_data)

    async def add_role_neops_task(
        self,
        neops_task_id: Union[Optional[str], UnsetType] = UNSET,
        role_id: Union[Optional[str], UnsetType] = UNSET,
        permission: Union[Optional[int], UnsetType] = UNSET,
        **kwargs: Any
    ) -> AddRoleNeopsTask:
        _query = gql(
            """
            mutation addRoleNeopsTask($neopsTaskId: ID, $roleId: ID, $permission: Int) {
              roleNeopsTaskUpsert(
                neopsTaskId: $neopsTaskId
                roleId: $roleId
                permission: $permission
              ) {
                roleNeopsTask {
                  role {
                    id
                    users {
                      id
                      username
                    }
                  }
                  neopsTask {
                    id
                    name
                  }
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "neopsTaskId": neops_task_id,
            "roleId": role_id,
            "permission": permission,
        }
        _response = await self.execute(
            query=_query,
            operation_name="addRoleNeopsTask",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return AddRoleNeopsTask.model_validate(_data)

    async def add_user(
        self,
        username: str,
        password: str,
        email: Union[Optional[str], UnsetType] = UNSET,
        first_name: Union[Optional[str], UnsetType] = UNSET,
        last_name: Union[Optional[str], UnsetType] = UNSET,
        **kwargs: Any
    ) -> AddUser:
        _query = gql(
            """
            mutation addUser($username: String!, $password: String!, $email: String, $firstName: String, $lastName: String) {
              localUserCreate(
                username: $username
                password: $password
                email: $email
                firstName: $firstName
                lastName: $lastName
              ) {
                localUser {
                  id
                  username
                  password
                  isActive
                  isSuperuser
                  firstName
                  lastName
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "username": username,
            "password": password,
            "email": email,
            "firstName": first_name,
            "lastName": last_name,
        }
        _response = await self.execute(
            query=_query, operation_name="addUser", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return AddUser.model_validate(_data)

    async def add_users_to_role(
        self,
        id: Union[Optional[str], UnsetType] = UNSET,
        users: Union[Optional[List[Optional[str]]], UnsetType] = UNSET,
        **kwargs: Any
    ) -> AddUsersToRole:
        _query = gql(
            """
            mutation addUsersToRole($id: ID, $users: [ID]) {
              roleAddUsers(id: $id, users: $users) {
                role {
                  id
                  name
                  users {
                    id
                    username
                  }
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {"id": id, "users": users}
        _response = await self.execute(
            query=_query,
            operation_name="addUsersToRole",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return AddUsersToRole.model_validate(_data)

    async def archive_or_delete_task(
        self,
        id: str,
        hard_delete: Union[Optional[bool], UnsetType] = UNSET,
        **kwargs: Any
    ) -> ArchiveOrDeleteTask:
        _query = gql(
            """
            mutation archiveOrDeleteTask($id: ID!, $hardDelete: Boolean = false) {
              neopsTaskDelete(id: $id, hardDelete: $hardDelete) {
                neopsTask {
                  id
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {"id": id, "hardDelete": hard_delete}
        _response = await self.execute(
            query=_query,
            operation_name="archiveOrDeleteTask",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return ArchiveOrDeleteTask.model_validate(_data)

    async def autocomplete_fields(self, **kwargs: Any) -> AutocompleteFields:
        _query = gql(
            """
            query autocompleteFields {
              searchFields(index: GLOBAL)
            }
            """
        )
        _variables: Dict[str, object] = {}
        _response = await self.execute(
            query=_query,
            operation_name="autocompleteFields",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return AutocompleteFields.model_validate(_data)

    async def client_aggregation(
        self,
        aggr_field: str,
        query: Union[Optional[str], UnsetType] = UNSET,
        **kwargs: Any
    ) -> ClientAggregation:
        _query = gql(
            """
            query clientAggregation($aggrField: String!, $query: String) {
              clientAggregation(aggrField: $aggrField, query: $query, queryTypeGlobal: true) {
                results {
                  value
                  count
                }
                countAggregatedElements
                count
              }
            }
            """
        )
        _variables: Dict[str, object] = {"aggrField": aggr_field, "query": query}
        _response = await self.execute(
            query=_query,
            operation_name="clientAggregation",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return ClientAggregation.model_validate(_data)

    async def client_result(
        self,
        execution_id: Union[Optional[str], UnsetType] = UNSET,
        process_id: Union[Optional[str], UnsetType] = UNSET,
        execution_type: Union[Optional[ExecutionTypeEnum], UnsetType] = UNSET,
        scope: Union[Optional[Any], UnsetType] = UNSET,
        **kwargs: Any
    ) -> ClientResult:
        _query = gql(
            """
            query clientResult($executionId: ID, $processId: ID, $executionType: ExecutionTypeEnum, $scope: Decimal) {
              clientResult(
                execution_Process: $processId
                execution: $executionId
                execution_ExecutionType: $executionType
                scope: $scope
              ) {
                results {
                  id
                  state
                  message
                  granularity
                  neopsTask {
                    id
                    name
                  }
                  client {
                    id
                    macaddress
                  }
                  execution {
                    id
                    runOn
                  }
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "executionId": execution_id,
            "processId": process_id,
            "executionType": execution_type,
            "scope": scope,
        }
        _response = await self.execute(
            query=_query, operation_name="clientResult", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return ClientResult.model_validate(_data)

    async def clients(
        self,
        query: Union[Optional[str], UnsetType] = UNSET,
        page: Union[Optional[int], UnsetType] = UNSET,
        page_size: Union[Optional[int], UnsetType] = UNSET,
        ordering: Union[Optional[str], UnsetType] = UNSET,
        scope: Union[Optional[Any], UnsetType] = UNSET,
        id: Union[Optional[str], UnsetType] = UNSET,
        **kwargs: Any
    ) -> Clients:
        _query = gql(
            """
            query clients($query: String, $page: Int, $pageSize: Int, $ordering: String, $scope: Decimal, $id: ID) {
              clientsElastic(id: $id, query: $query, queryTypeGlobal: true, scope: $scope) {
                totalCount
                results(page: $page, pageSize: $pageSize, ordering: $ordering) {
                  id
                  createdAt
                  updatedAt
                  fromimport
                  lastdiscovered
                  macaddress
                  facts
                  interface {
                    id
                    name
                    device {
                      id
                      hostname
                      ip
                    }
                  }
                  location {
                    id
                    name
                    address
                    city
                    country
                    lat
                    lon
                  }
                  checks
                  checkElements(validTill_Isnull: true, scope: $scope) {
                    id
                    key
                    reason
                    result
                    metrics
                    neopsTask {
                      id
                      name
                    }
                  }
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "query": query,
            "page": page,
            "pageSize": page_size,
            "ordering": ordering,
            "scope": scope,
            "id": id,
        }
        _response = await self.execute(
            query=_query, operation_name="clients", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return Clients.model_validate(_data)

    async def cron_execution_type(
        self,
        cron_execute_type: Union[Optional[CronExecuteTypeEnum], UnsetType] = UNSET,
        **kwargs: Any
    ) -> CronExecutionType:
        _query = gql(
            """
            query cronExecutionType($cronExecuteType: CronExecuteTypeEnum) {
              cronjobExecutionTypes(cronExecuteType: $cronExecuteType) {
                results {
                  form
                  cronExecuteType
                }
                totalCount
              }
            }
            """
        )
        _variables: Dict[str, object] = {"cronExecuteType": cron_execute_type}
        _response = await self.execute(
            query=_query,
            operation_name="cronExecutionType",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return CronExecutionType.model_validate(_data)

    async def device_aggregation(
        self,
        aggr_field: str,
        query: Union[Optional[str], UnsetType] = UNSET,
        **kwargs: Any
    ) -> DeviceAggregation:
        _query = gql(
            """
            query deviceAggregation($aggrField: String!, $query: String) {
              deviceAggregation(aggrField: $aggrField, query: $query, queryTypeGlobal: true) {
                results {
                  value
                  count
                }
                countAggregatedElements
                count
              }
            }
            """
        )
        _variables: Dict[str, object] = {"aggrField": aggr_field, "query": query}
        _response = await self.execute(
            query=_query,
            operation_name="deviceAggregation",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return DeviceAggregation.model_validate(_data)

    async def device_group_elastic(
        self,
        page: Union[Optional[int], UnsetType] = UNSET,
        page_size: Union[Optional[int], UnsetType] = UNSET,
        ordering: Union[Optional[str], UnsetType] = UNSET,
        query: Union[Optional[str], UnsetType] = UNSET,
        id: Union[Optional[str], UnsetType] = UNSET,
        permission: Union[Optional[str], UnsetType] = UNSET,
        scope: Union[Optional[Any], UnsetType] = UNSET,
        **kwargs: Any
    ) -> DeviceGroupElastic:
        _query = gql(
            """
            query deviceGroupElastic($page: Int = 1, $pageSize: Int = 999, $ordering: String = "name", $query: String = "", $id: ID, $permission: String = "read", $scope: Decimal) {
              groupsElastic(
                query: $query
                queryTypeGlobal: true
                id: $id
                permission: $permission
                scope: $scope
              ) {
                totalCount
                results(page: $page, pageSize: $pageSize, ordering: $ordering) {
                  id
                  name
                  title
                  description
                  location {
                    id
                    address
                    city
                    zipCode
                    lon
                    lat
                  }
                  deviceCount
                  permission
                  checks
                  facts
                  checkElements(validTill_Isnull: true, scope: $scope) {
                    id
                    key
                    reason
                    result
                    metrics
                    neopsTask {
                      id
                      name
                    }
                  }
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "page": page,
            "pageSize": page_size,
            "ordering": ordering,
            "query": query,
            "id": id,
            "permission": permission,
            "scope": scope,
        }
        _response = await self.execute(
            query=_query,
            operation_name="deviceGroupElastic",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return DeviceGroupElastic.model_validate(_data)

    async def device_group_result(
        self,
        execution: Union[Optional[str], UnsetType] = UNSET,
        process_id: Union[Optional[str], UnsetType] = UNSET,
        execution_type: Union[Optional[ExecutionTypeEnum], UnsetType] = UNSET,
        **kwargs: Any
    ) -> DeviceGroupResult:
        _query = gql(
            """
            query deviceGroupResult($execution: ID, $processId: ID, $executionType: ExecutionTypeEnum) {
              groupResult(
                execution: $execution
                execution_Process: $processId
                execution_ExecutionType: $executionType
              ) {
                results {
                  id
                  state
                  message
                  granularity
                  neopsTask {
                    id
                    name
                  }
                  group {
                    id
                    name
                  }
                  execution {
                    id
                    runOn
                  }
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "execution": execution,
            "processId": process_id,
            "executionType": execution_type,
        }
        _response = await self.execute(
            query=_query,
            operation_name="deviceGroupResult",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return DeviceGroupResult.model_validate(_data)

    async def device_group_upsert(
        self,
        description: Union[Optional[str], UnsetType] = UNSET,
        devices: Union[Optional[List[Optional[str]]], UnsetType] = UNSET,
        id: Union[Optional[str], UnsetType] = UNSET,
        name: Union[Optional[str], UnsetType] = UNSET,
        title: Union[Optional[str], UnsetType] = UNSET,
        **kwargs: Any
    ) -> DeviceGroupUpsert:
        _query = gql(
            """
            mutation deviceGroupUpsert($description: String, $devices: [ID], $id: ID, $name: String, $title: String) {
              deviceGroupUpsert(
                description: $description
                devices: $devices
                id: $id
                name: $name
                title: $title
              ) {
                deviceGroup {
                  id
                  name
                  description
                  title
                  devices {
                    id
                    hostname
                    ip
                  }
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "description": description,
            "devices": devices,
            "id": id,
            "name": name,
            "title": title,
        }
        _response = await self.execute(
            query=_query,
            operation_name="deviceGroupUpsert",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return DeviceGroupUpsert.model_validate(_data)

    async def device_result(
        self,
        execution: Union[Optional[str], UnsetType] = UNSET,
        process_id: Union[Optional[str], UnsetType] = UNSET,
        execution_type: Union[Optional[ExecutionTypeEnum], UnsetType] = UNSET,
        scope: Union[Optional[Any], UnsetType] = UNSET,
        **kwargs: Any
    ) -> DeviceResult:
        _query = gql(
            """
            query deviceResult($execution: ID, $processId: ID, $executionType: ExecutionTypeEnum, $scope: Decimal) {
              deviceResult(
                execution: $execution
                execution_Process: $processId
                execution_ExecutionType: $executionType
                scope: $scope
              ) {
                results {
                  id
                  state
                  message
                  granularity
                  neopsTask {
                    id
                    name
                  }
                  device {
                    id
                    hostname
                  }
                  execution {
                    id
                    runOn
                  }
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "execution": execution,
            "processId": process_id,
            "executionType": execution_type,
            "scope": scope,
        }
        _response = await self.execute(
            query=_query, operation_name="deviceResult", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return DeviceResult.model_validate(_data)

    async def device_upsert(
        self,
        connection_options: Union[Optional[Any], UnsetType] = UNSET,
        groups: Union[Optional[List[Optional[str]]], UnsetType] = UNSET,
        hostname: Union[Optional[str], UnsetType] = UNSET,
        id: Union[Optional[str], UnsetType] = UNSET,
        ip: Union[Optional[str], UnsetType] = UNSET,
        password: Union[Optional[str], UnsetType] = UNSET,
        platform: Union[Optional[str], UnsetType] = UNSET,
        username: Union[Optional[str], UnsetType] = UNSET,
        **kwargs: Any
    ) -> DeviceUpsert:
        _query = gql(
            """
            mutation deviceUpsert($connectionOptions: JSONString, $groups: [ID], $hostname: String, $id: ID, $ip: String, $password: String, $platform: ID, $username: String) {
              deviceUpsert(
                connectionOptions: $connectionOptions
                groups: $groups
                hostname: $hostname
                id: $id
                ip: $ip
                password: $password
                platform: $platform
                username: $username
              ) {
                device {
                  id
                  hostname
                  connectionOptions
                  ip
                  groups {
                    id
                    name
                  }
                  platform {
                    id
                    name
                  }
                  username
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "connectionOptions": connection_options,
            "groups": groups,
            "hostname": hostname,
            "id": id,
            "ip": ip,
            "password": password,
            "platform": platform,
            "username": username,
        }
        _response = await self.execute(
            query=_query, operation_name="deviceUpsert", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return DeviceUpsert.model_validate(_data)

    async def devices(
        self,
        query: Union[Optional[str], UnsetType] = UNSET,
        page: Union[Optional[int], UnsetType] = UNSET,
        page_size: Union[Optional[int], UnsetType] = UNSET,
        id: Union[Optional[str], UnsetType] = UNSET,
        ordering: Union[Optional[str], UnsetType] = UNSET,
        scope: Union[Optional[Any], UnsetType] = UNSET,
        **kwargs: Any
    ) -> Devices:
        _query = gql(
            """
            query devices($query: String = "", $page: Int = 1, $pageSize: Int = 999, $id: ID, $ordering: String = "hostname", $scope: Decimal) {
              devicesElastic(query: $query, queryTypeGlobal: true, id: $id, scope: $scope) {
                totalCount
                results(page: $page, pageSize: $pageSize, ordering: $ordering) {
                  id
                  createdAt
                  updatedAt
                  hostname
                  ip
                  connectionState
                  connectionOptions
                  facts
                  softwareRelease
                  platform {
                    id
                    name
                  }
                  vendor
                  model
                  serial
                  username
                  currentConfiguration
                  groups {
                    id
                    name
                    title
                    description
                    location {
                      id
                      address
                      name
                      city
                      zipCode
                      lon
                      lat
                    }
                  }
                  interfaces {
                    id
                    name
                    ifindex
                    description
                    state
                    interface {
                      id
                    }
                  }
                  permission
                  checks
                  checkElements(validTill_Isnull: true, scope: $scope) {
                    id
                    key
                    reason
                    result
                    metrics
                    neopsTask {
                      id
                      name
                    }
                  }
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "query": query,
            "page": page,
            "pageSize": page_size,
            "id": id,
            "ordering": ordering,
            "scope": scope,
        }
        _response = await self.execute(
            query=_query, operation_name="devices", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return Devices.model_validate(_data)

    async def discovery(
        self, arguments: Union[Optional[Any], UnsetType] = UNSET, **kwargs: Any
    ) -> Discovery:
        _query = gql(
            """
            mutation discovery($arguments: JSONString) {
              execute(task: "discover_device", arguments: $arguments) {
                execution {
                  id
                  taskId
                  state
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {"arguments": arguments}
        _response = await self.execute(
            query=_query, operation_name="discovery", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return Discovery.model_validate(_data)

    async def execute_neops_task(
        self,
        neops_task_id: str,
        dry_run: Union[Optional[bool], UnsetType] = UNSET,
        execute_on: Union[Optional[List[Optional[str]]], UnsetType] = UNSET,
        execute_on_type: Union[Optional[RunOnEnum], UnsetType] = UNSET,
        name: Union[Optional[str], UnsetType] = UNSET,
        process_execution_id: Union[Optional[str], UnsetType] = UNSET,
        task_arguments: Union[Optional[Any], UnsetType] = UNSET,
        run_synchronous: Union[Optional[bool], UnsetType] = UNSET,
        unique_task_name: Union[Optional[str], UnsetType] = UNSET,
        synchronous_timeout: Union[Optional[int], UnsetType] = UNSET,
        search_query: Union[Optional[str], UnsetType] = UNSET,
        **kwargs: Any
    ) -> ExecuteNeopsTask:
        _query = gql(
            """
            mutation executeNeopsTask($dryRun: Boolean, $executeOn: [ID], $executeOnType: RunOnEnum, $name: String, $neopsTaskId: ID!, $processExecutionId: ID, $taskArguments: JSONString, $runSynchronous: Boolean, $uniqueTaskName: String, $synchronousTimeout: Int, $searchQuery: String) {
              executeNeopsTask(
                dryRun: $dryRun
                executeOn: $executeOn
                executeOnType: $executeOnType
                name: $name
                neopsTaskId: $neopsTaskId
                processExecutionId: $processExecutionId
                taskArguments: $taskArguments
                runSynchronous: $runSynchronous
                uniquetaskname: $uniqueTaskName
                synchronousTimeout: $synchronousTimeout
                searchQuery: $searchQuery
              ) {
                executions {
                  args
                  id
                  taskId
                  name
                  createdAt
                  updatedAt
                  state
                  executionType
                  taskId
                  task
                  neopsTask {
                    id
                    name
                    description
                    provider {
                      providerType
                    }
                  }
                  deviceExecution {
                    execution {
                      id
                    }
                    id
                    device {
                      id
                      hostname
                      vendor
                      model
                      platform {
                        id
                        name
                      }
                      softwareRelease
                    }
                    runOn
                    executeOn
                    state
                    exception
                    do
                    done
                    changed
                    willChange
                    log
                  }
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "dryRun": dry_run,
            "executeOn": execute_on,
            "executeOnType": execute_on_type,
            "name": name,
            "neopsTaskId": neops_task_id,
            "processExecutionId": process_execution_id,
            "taskArguments": task_arguments,
            "runSynchronous": run_synchronous,
            "uniqueTaskName": unique_task_name,
            "synchronousTimeout": synchronous_timeout,
            "searchQuery": search_query,
        }
        _response = await self.execute(
            query=_query,
            operation_name="executeNeopsTask",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return ExecuteNeopsTask.model_validate(_data)

    async def execution(
        self, id: Union[Optional[Any], UnsetType] = UNSET, **kwargs: Any
    ) -> Execution:
        _query = gql(
            """
            query execution($id: Decimal) {
              executions(id: $id) {
                results {
                  id
                  taskId
                  name
                  executionType
                  createdAt
                  updatedAt
                  log
                  do
                  done
                  process {
                    name
                    id
                  }
                  neopsTask {
                    id
                    name
                    description
                    provider {
                      providerType
                    }
                  }
                  state
                  deviceExecution {
                    id
                    device {
                      id
                      hostname
                      platform {
                        id
                        name
                      }
                    }
                    runOn
                    executeOn
                    state
                    result
                    do
                    exception
                    done
                    changed
                    log
                  }
                  executionResults {
                    devicegroupexecutionresult {
                      group {
                        name
                      }
                      granularity
                      message
                      state
                    }
                    deviceexecutionresult {
                      device {
                        hostname
                      }
                      granularity
                      message
                      state
                    }
                    clientexecutionresult {
                      client {
                        macaddress
                      }
                      granularity
                      message
                      state
                    }
                    interfaceexecutionresult {
                      interface {
                        name
                      }
                      granularity
                      message
                      state
                    }
                  }
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {"id": id}
        _response = await self.execute(
            query=_query, operation_name="execution", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return Execution.model_validate(_data)

    async def execution_subscription(
        self, **kwargs: Any
    ) -> AsyncIterator[ExecutionSubscription]:
        _query = gql(
            """
            subscription executionSubscription {
              executionSubscription {
                execution {
                  id
                  taskId
                  name
                  createdAt
                  updatedAt
                  state
                  executionType
                  args
                  do
                  done
                  log
                  process {
                    id
                    name
                  }
                  neopsTask {
                    id
                    name
                    description
                    provider {
                      providerType
                    }
                  }
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {}
        async for _data in self.execute_ws(
            query=_query,
            operation_name="executionSubscription",
            variables=_variables,
            **kwargs
        ):
            yield ExecutionSubscription.model_validate(_data)

    async def executions(
        self,
        execution_type: Union[Optional[ExecutionTypeEnum], UnsetType] = UNSET,
        page: Union[Optional[int], UnsetType] = UNSET,
        page_size: Union[Optional[int], UnsetType] = UNSET,
        ordering: Union[Optional[str], UnsetType] = UNSET,
        state: Union[Optional[str], UnsetType] = UNSET,
        check_id: Union[Optional[Any], UnsetType] = UNSET,
        user_id: Union[Optional[str], UnsetType] = UNSET,
        user_username: Union[Optional[str], UnsetType] = UNSET,
        updated_at_gt: Union[Optional[Any], UnsetType] = UNSET,
        created_at_gt: Union[Optional[Any], UnsetType] = UNSET,
        **kwargs: Any
    ) -> Executions:
        _query = gql(
            """
            query executions($executionType: ExecutionTypeEnum, $page: Int, $pageSize: Int, $ordering: String = "name", $state: String, $checkId: Decimal, $user_Id: ID, $user_Username: String, $updatedAt_Gt: CustomDateTime, $createdAt_Gt: CustomDateTime) {
              executions(
                states: $state
                process_Isnull: false
                executionType: $executionType
                checkId: $checkId
                user_Id: $user_Id
                user_Username: $user_Username
                updatedAt_Gt: $updatedAt_Gt
                createdAt_Gt: $createdAt_Gt
              ) {
                totalCount
                results(page: $page, pageSize: $pageSize, ordering: $ordering) {
                  id
                  taskId
                  name
                  executionType
                  createdAt
                  updatedAt
                  state
                  user {
                    username
                    lastName
                    firstName
                    email
                    id
                  }
                  process {
                    name
                    id
                  }
                  neopsTask {
                    id
                    name
                    description
                    provider {
                      providerType
                    }
                  }
                  executionResults {
                    devicegroupexecutionresult {
                      group {
                        name
                      }
                      granularity
                      message
                      state
                    }
                    deviceexecutionresult {
                      device {
                        hostname
                      }
                      granularity
                      message
                      state
                    }
                    clientexecutionresult {
                      client {
                        macaddress
                      }
                      granularity
                      message
                      state
                    }
                    interfaceexecutionresult {
                      interface {
                        name
                      }
                      granularity
                      message
                      state
                    }
                  }
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "executionType": execution_type,
            "page": page,
            "pageSize": page_size,
            "ordering": ordering,
            "state": state,
            "checkId": check_id,
            "user_Id": user_id,
            "user_Username": user_username,
            "updatedAt_Gt": updated_at_gt,
            "createdAt_Gt": created_at_gt,
        }
        _response = await self.execute(
            query=_query, operation_name="executions", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return Executions.model_validate(_data)

    async def executions_elastic(
        self,
        query: Union[Optional[str], UnsetType] = UNSET,
        page: Union[Optional[int], UnsetType] = UNSET,
        page_size: Union[Optional[int], UnsetType] = UNSET,
        id: Union[Optional[str], UnsetType] = UNSET,
        ordering: Union[Optional[str], UnsetType] = UNSET,
        permission: Union[Optional[str], UnsetType] = UNSET,
        scope: Union[Optional[Any], UnsetType] = UNSET,
        **kwargs: Any
    ) -> ExecutionsElastic:
        _query = gql(
            """
            query executionsElastic($query: String = "", $page: Int = 1, $pageSize: Int = 999, $id: ID, $ordering: String = "id", $permission: String, $scope: Decimal) {
              executionsElastic(
                query: $query
                queryTypeGlobal: true
                id: $id
                permission: $permission
                scope: $scope
              ) {
                totalCount
                results(page: $page, pageSize: $pageSize, ordering: $ordering) {
                  id
                  taskId
                  name
                  executionType
                  createdAt
                  updatedAt
                  user {
                    username
                    lastName
                    firstName
                    email
                  }
                  process {
                    name
                    id
                  }
                  neopsTask {
                    id
                    name
                    description
                    provider {
                      providerType
                    }
                  }
                  state
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "query": query,
            "page": page,
            "pageSize": page_size,
            "id": id,
            "ordering": ordering,
            "permission": permission,
            "scope": scope,
        }
        _response = await self.execute(
            query=_query,
            operation_name="executionsElastic",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return ExecutionsElastic.model_validate(_data)

    async def get_role(
        self, name: Union[Optional[str], UnsetType] = UNSET, **kwargs: Any
    ) -> GetRole:
        _query = gql(
            """
            query getRole($name: String) {
              role(name: $name) {
                results {
                  id
                  name
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {"name": name}
        _response = await self.execute(
            query=_query, operation_name="getRole", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return GetRole.model_validate(_data)

    async def group_aggregation(
        self,
        aggr_field: str,
        query: Union[Optional[str], UnsetType] = UNSET,
        **kwargs: Any
    ) -> GroupAggregation:
        _query = gql(
            """
            query groupAggregation($aggrField: String!, $query: String) {
              groupAggregation(aggrField: $aggrField, query: $query, queryTypeGlobal: true) {
                results {
                  value
                  count
                }
                countAggregatedElements
                count
              }
            }
            """
        )
        _variables: Dict[str, object] = {"aggrField": aggr_field, "query": query}
        _response = await self.execute(
            query=_query,
            operation_name="groupAggregation",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return GroupAggregation.model_validate(_data)

    async def interface_aggregation(
        self,
        aggr_field: str,
        query: Union[Optional[str], UnsetType] = UNSET,
        **kwargs: Any
    ) -> InterfaceAggregation:
        _query = gql(
            """
            query interfaceAggregation($aggrField: String!, $query: String) {
              interfaceAggregation(
                aggrField: $aggrField
                query: $query
                queryTypeGlobal: true
              ) {
                results {
                  value
                  count
                }
                countAggregatedElements
                count
              }
            }
            """
        )
        _variables: Dict[str, object] = {"aggrField": aggr_field, "query": query}
        _response = await self.execute(
            query=_query,
            operation_name="interfaceAggregation",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return InterfaceAggregation.model_validate(_data)

    async def interface_result(
        self,
        execution: Union[Optional[str], UnsetType] = UNSET,
        process_id: Union[Optional[str], UnsetType] = UNSET,
        execution_type: Union[Optional[ExecutionTypeEnum], UnsetType] = UNSET,
        scope: Union[Optional[Any], UnsetType] = UNSET,
        **kwargs: Any
    ) -> InterfaceResult:
        _query = gql(
            """
            query interfaceResult($execution: ID, $processId: ID, $executionType: ExecutionTypeEnum, $scope: Decimal) {
              interfaceResult(
                execution: $execution
                execution_Process: $processId
                execution_ExecutionType: $executionType
                scope: $scope
              ) {
                results {
                  id
                  state
                  message
                  granularity
                  neopsTask {
                    id
                    name
                  }
                  interface {
                    id
                    name
                    device {
                      id
                      hostname
                    }
                  }
                  execution {
                    id
                    runOn
                  }
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "execution": execution,
            "processId": process_id,
            "executionType": execution_type,
            "scope": scope,
        }
        _response = await self.execute(
            query=_query,
            operation_name="interfaceResult",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return InterfaceResult.model_validate(_data)

    async def interfaces(
        self,
        query: Union[Optional[str], UnsetType] = UNSET,
        page: Union[Optional[int], UnsetType] = UNSET,
        page_size: Union[Optional[int], UnsetType] = UNSET,
        ordering: Union[Optional[str], UnsetType] = UNSET,
        scope: Union[Optional[Any], UnsetType] = UNSET,
        id: Union[Optional[str], UnsetType] = UNSET,
        **kwargs: Any
    ) -> Interfaces:
        _query = gql(
            """
            query interfaces($query: String, $page: Int, $pageSize: Int, $ordering: String = "device__hostname,name", $scope: Decimal, $id: ID) {
              interfacesElastic(query: $query, queryTypeGlobal: true, scope: $scope, id: $id) {
                totalCount
                results(page: $page, pageSize: $pageSize, ordering: $ordering) {
                  id
                  createdAt
                  updatedAt
                  name
                  description
                  state
                  facts
                  currentConfiguration
                  interface {
                    id
                  }
                  device {
                    id
                    hostname
                    model
                    ip
                    facts
                    platform {
                      id
                      name
                    }
                    groups(location_Isnull: false) {
                      id
                      location {
                        id
                        address
                        name
                        city
                        zipCode
                        lon
                        lat
                      }
                    }
                  }
                  permission
                  checks
                  clients {
                    id
                  }
                  checkElements(validTill_Isnull: true, scope: $scope) {
                    id
                    key
                    reason
                    result
                    metrics
                    neopsTask {
                      id
                      name
                    }
                  }
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "query": query,
            "page": page,
            "pageSize": page_size,
            "ordering": ordering,
            "scope": scope,
            "id": id,
        }
        _response = await self.execute(
            query=_query, operation_name="interfaces", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return Interfaces.model_validate(_data)

    async def location_upsert(
        self,
        id: Union[Optional[str], UnsetType] = UNSET,
        name: Union[Optional[str], UnsetType] = UNSET,
        devices: Union[Optional[List[Optional[str]]], UnsetType] = UNSET,
        description: Union[Optional[str], UnsetType] = UNSET,
        title: Union[Optional[str], UnsetType] = UNSET,
        address: Union[Optional[str], UnsetType] = UNSET,
        zip_code: Union[Optional[str], UnsetType] = UNSET,
        city: Union[Optional[str], UnsetType] = UNSET,
        country: Union[Optional[str], UnsetType] = UNSET,
        lat: Union[Optional[Any], UnsetType] = UNSET,
        lon: Union[Optional[Any], UnsetType] = UNSET,
        **kwargs: Any
    ) -> LocationUpsert:
        _query = gql(
            """
            mutation locationUpsert($id: ID, $name: String, $devices: [ID], $description: String, $title: String, $address: String, $zipCode: String, $city: String, $country: String, $lat: Decimal, $lon: Decimal) {
              locationUpsert(
                id: $id
                name: $name
                devices: $devices
                description: $description
                address: $address
                zipCode: $zipCode
                city: $city
                title: $title
                country: $country
                lat: $lat
                lon: $lon
              ) {
                location {
                  id
                  name
                  title
                  description
                  address
                  zipCode
                  city
                  country
                  devices {
                    id
                    hostname
                    ip
                  }
                  lon
                  lat
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "id": id,
            "name": name,
            "devices": devices,
            "description": description,
            "title": title,
            "address": address,
            "zipCode": zip_code,
            "city": city,
            "country": country,
            "lat": lat,
            "lon": lon,
        }
        _response = await self.execute(
            query=_query,
            operation_name="locationUpsert",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return LocationUpsert.model_validate(_data)

    async def login(
        self,
        username: Union[Optional[str], UnsetType] = UNSET,
        password: Union[Optional[str], UnsetType] = UNSET,
        **kwargs: Any
    ) -> Login:
        _query = gql(
            """
            mutation login($username: String, $password: String) {
              login(username: $username, password: $password) {
                accessToken
                refreshToken
                roles
              }
            }
            """
        )
        _variables: Dict[str, object] = {"username": username, "password": password}
        _response = await self.execute(
            query=_query, operation_name="login", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return Login.model_validate(_data)

    async def reports_execute(
        self,
        id: Union[Optional[str], UnsetType] = UNSET,
        uniquereportname: Union[Optional[str], UnsetType] = UNSET,
        execute_on: Union[Optional[List[Optional[str]]], UnsetType] = UNSET,
        execute_on_type: Union[Optional[RunOnEnum], UnsetType] = UNSET,
        search_query: Union[Optional[str], UnsetType] = UNSET,
        scope: Union[Optional[int], UnsetType] = UNSET,
        **kwargs: Any
    ) -> ReportsExecute:
        _query = gql(
            """
            mutation reportsExecute($id: ID, $uniquereportname: String, $executeOn: [ID], $executeOnType: RunOnEnum, $searchQuery: String, $scope: Int) {
              reportsExecute(
                id: $id
                uniquereportname: $uniquereportname
                executeOn: $executeOn
                executeOnType: $executeOnType
                searchQuery: $searchQuery
                scope: $scope
              ) {
                reportExecution {
                  contentBase64
                  extension
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "id": id,
            "uniquereportname": uniquereportname,
            "executeOn": execute_on,
            "executeOnType": execute_on_type,
            "searchQuery": search_query,
            "scope": scope,
        }
        _response = await self.execute(
            query=_query,
            operation_name="reportsExecute",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return ReportsExecute.model_validate(_data)

    async def neops_task_unarchive(self, id: str, **kwargs: Any) -> NeopsTaskUnarchive:
        _query = gql(
            """
            mutation neopsTaskUnarchive($id: ID!) {
              neopsTaskUpsert(id: $id, unarchive: true) {
                neopsTask {
                  id
                  name
                  deletedAt
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {"id": id}
        _response = await self.execute(
            query=_query,
            operation_name="neopsTaskUnarchive",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return NeopsTaskUnarchive.model_validate(_data)

    async def neops_task_create_mutation(
        self,
        id: Union[Optional[str], UnsetType] = UNSET,
        description: Union[Optional[str], UnsetType] = UNSET,
        name: Union[Optional[str], UnsetType] = UNSET,
        provider_identifier: Union[Optional[str], UnsetType] = UNSET,
        task_kwargs: Union[Optional[str], UnsetType] = UNSET,
        task_run_input_schema: Union[Optional[str], UnsetType] = UNSET,
        task_run_filter: Union[Optional[str], UnsetType] = UNSET,
        pre_run_tasks: Union[Optional[List[Optional[str]]], UnsetType] = UNSET,
        post_run_tasks: Union[Optional[List[Optional[str]]], UnsetType] = UNSET,
        uniquetaskname: Union[Optional[str], UnsetType] = UNSET,
        scope_id: Union[Optional[str], UnsetType] = UNSET,
        **kwargs: Any
    ) -> NeopsTaskCreateMutation:
        _query = gql(
            """
            mutation neopsTaskCreateMutation($id: ID, $description: String, $name: String, $providerIdentifier: String, $taskKwargs: String, $taskRunInputSchema: String, $taskRunFilter: String, $preRunTasks: [ID], $postRunTasks: [ID], $uniquetaskname: String, $scopeId: ID) {
              neopsTaskUpsert(
                id: $id
                description: $description
                name: $name
                providerIdentifier: $providerIdentifier
                taskKwargs: $taskKwargs
                taskRunInputSchema: $taskRunInputSchema
                taskRunFilter: $taskRunFilter
                preRunTasks: $preRunTasks
                postRunTasks: $postRunTasks
                uniquetaskname: $uniquetaskname
                scopeId: $scopeId
              ) {
                neopsTask {
                  id
                  name
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "id": id,
            "description": description,
            "name": name,
            "providerIdentifier": provider_identifier,
            "taskKwargs": task_kwargs,
            "taskRunInputSchema": task_run_input_schema,
            "taskRunFilter": task_run_filter,
            "preRunTasks": pre_run_tasks,
            "postRunTasks": post_run_tasks,
            "uniquetaskname": uniquetaskname,
            "scopeId": scope_id,
        }
        _response = await self.execute(
            query=_query,
            operation_name="neopsTaskCreateMutation",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return NeopsTaskCreateMutation.model_validate(_data)

    async def neops_tasks(
        self,
        id: Union[Optional[Any], UnsetType] = UNSET,
        permission: Union[Optional[str], UnsetType] = UNSET,
        scope: Union[Optional[Any], UnsetType] = UNSET,
        run_on: Union[Optional[str], UnsetType] = UNSET,
        unique_task_name_starts_with: Union[Optional[str], UnsetType] = UNSET,
        unique_task_name: Union[Optional[str], UnsetType] = UNSET,
        provider_identifier_contains: Union[Optional[str], UnsetType] = UNSET,
        provider_identifier: Union[Optional[str], UnsetType] = UNSET,
        show_archived_only: Union[Optional[bool], UnsetType] = UNSET,
        show_archived: Union[Optional[bool], UnsetType] = UNSET,
        **kwargs: Any
    ) -> NeopsTasks:
        _query = gql(
            """
            query neopsTasks($id: Decimal, $permission: String = "read", $scope: Decimal, $runOn: String, $uniqueTaskNameStartsWith: String, $uniqueTaskName: String, $providerIdentifierContains: String, $providerIdentifier: String, $showArchivedOnly: Boolean = false, $showArchived: Boolean = false) {
              neopsTasks(
                id: $id
                permission: $permission
                scope: $scope
                runOn: $runOn
                uniquetaskname_Istartswith: $uniqueTaskNameStartsWith
                uniquetaskname: $uniqueTaskName
                providerIdentifier: $providerIdentifier
                providerIdentifier_Icontains: $providerIdentifierContains
                showArchived: $showArchived
                showArchivedOnly: $showArchivedOnly
              ) {
                results {
                  id
                  name
                  description
                  uniquetaskname
                  providerIdentifier
                  runOn
                  runOnStrict
                  isCheck
                  isTask
                  provider {
                    name
                    jsonSchema
                    shortDescription
                    deprecated
                    description
                  }
                  taskKwargs
                  taskRunInputSchema
                  taskRunFilter
                  preRunTasks {
                    id
                    name
                  }
                  postRunTasks {
                    id
                    name
                  }
                  createdAt
                  updatedAt
                  permission
                  isValid
                  isValidRecursive
                  ValidityInformation
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "id": id,
            "permission": permission,
            "scope": scope,
            "runOn": run_on,
            "uniqueTaskNameStartsWith": unique_task_name_starts_with,
            "uniqueTaskName": unique_task_name,
            "providerIdentifierContains": provider_identifier_contains,
            "providerIdentifier": provider_identifier,
            "showArchivedOnly": show_archived_only,
            "showArchived": show_archived,
        }
        _response = await self.execute(
            query=_query, operation_name="neopsTasks", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return NeopsTasks.model_validate(_data)

    async def permissions(self, **kwargs: Any) -> Permissions:
        _query = gql(
            """
            query permissions {
              permissions {
                results {
                  name
                  description
                  defaultPermission
                  defaultPermissionFlags
                  permissionAllFlags
                  permission
                  permissionFlags
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {}
        _response = await self.execute(
            query=_query, operation_name="permissions", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return Permissions.model_validate(_data)

    async def platforms(
        self, scope: Union[Optional[Any], UnsetType] = UNSET, **kwargs: Any
    ) -> Platforms:
        _query = gql(
            """
            query platforms($scope: Decimal) {
              platforms(scope: $scope) {
                results {
                  id
                  name
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {"scope": scope}
        _response = await self.execute(
            query=_query, operation_name="platforms", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return Platforms.model_validate(_data)

    async def process_overview(
        self,
        process_id: Union[Optional[Any], UnsetType] = UNSET,
        scope: Union[Optional[Any], UnsetType] = UNSET,
        **kwargs: Any
    ) -> ProcessOverview:
        _query = gql(
            """
            query processOverview($processId: Decimal, $scope: Decimal) {
              processExecutions(id: $processId, scope: $scope) {
                results {
                  id
                  name
                  executions {
                    id
                    name
                    state
                    executionType
                    task
                    createdAt
                    updatedAt
                    args
                    do
                    done
                    log
                    executionResults {
                      id
                      state
                      message
                    }
                    neopsTask {
                      id
                      name
                      description
                      provider {
                        providerType
                      }
                    }
                    deviceExecution {
                      id
                      state
                      createdAt
                      updatedAt
                      changed
                      willChange
                      runOn
                      executeOn
                      device {
                        id
                        ip
                        hostname
                        vendor
                        model
                        platform {
                          id
                          name
                        }
                        softwareRelease
                      }
                    }
                  }
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {"processId": process_id, "scope": scope}
        _response = await self.execute(
            query=_query,
            operation_name="processOverview",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return ProcessOverview.model_validate(_data)

    async def neops_provider(
        self, name: Union[Optional[str], UnsetType] = UNSET, **kwargs: Any
    ) -> NeopsProvider:
        _query = gql(
            """
            query neopsProvider($name: String) {
              neopsTaskProvider(name: $name) {
                results {
                  name
                  description
                  runOn
                  runOnStrict
                  runOnAllIfEmpty
                  providerType
                  jsonSchema
                  module
                  shortDescription
                  deprecated
                  fullQualifiedName
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {"name": name}
        _response = await self.execute(
            query=_query, operation_name="neopsProvider", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return NeopsProvider.model_validate(_data)

    async def providers(self, **kwargs: Any) -> Providers:
        _query = gql(
            """
            query providers {
              neopsTaskProvider {
                results {
                  name
                  description
                  runOn
                  runOnStrict
                  runOnAllIfEmpty
                  providerType
                  fullQualifiedName
                  jsonSchema
                  module
                  shortDescription
                  deprecated
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {}
        _response = await self.execute(
            query=_query, operation_name="providers", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return Providers.model_validate(_data)

    async def reports(
        self,
        scope: Union[Optional[Any], UnsetType] = UNSET,
        type: Union[Optional[str], UnsetType] = UNSET,
        **kwargs: Any
    ) -> Reports:
        _query = gql(
            """
            query reports($scope: Decimal, $type: String) {
              reports(scope: $scope, type: $type) {
                results {
                  id
                  name
                  extension
                  uniquereportname
                  jinjaTemplate
                  entityType
                  scope {
                    id
                    name
                  }
                  permission
                  updatedAt
                  createdAt
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {"scope": scope, "type": type}
        _response = await self.execute(
            query=_query, operation_name="reports", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return Reports.model_validate(_data)

    async def refresh_token(
        self, refresh_token: Union[Optional[str], UnsetType] = UNSET, **kwargs: Any
    ) -> RefreshToken:
        _query = gql(
            """
            mutation refreshToken($refreshToken: String) {
              refreshToken(refreshToken: $refreshToken) {
                accessToken
                refreshToken
              }
            }
            """
        )
        _variables: Dict[str, object] = {"refreshToken": refresh_token}
        _response = await self.execute(
            query=_query, operation_name="refreshToken", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return RefreshToken.model_validate(_data)

    async def role_device_group(self, **kwargs: Any) -> RoleDeviceGroup:
        _query = gql(
            """
            query roleDeviceGroup {
              roleDeviceGroup {
                results {
                  id
                  role {
                    id
                    name
                  }
                  deviceGroup {
                    id
                    name
                  }
                  permission
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {}
        _response = await self.execute(
            query=_query,
            operation_name="roleDeviceGroup",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return RoleDeviceGroup.model_validate(_data)

    async def role_device_group_upsert(
        self,
        role_id: Union[Optional[str], UnsetType] = UNSET,
        device_group_id: Union[Optional[str], UnsetType] = UNSET,
        permission: Union[Optional[int], UnsetType] = UNSET,
        **kwargs: Any
    ) -> RoleDeviceGroupUpsert:
        _query = gql(
            """
            mutation roleDeviceGroupUpsert($roleId: ID, $deviceGroupId: ID, $permission: Int) {
              roleDeviceGroupUpsert(
                roleId: $roleId
                deviceGroupId: $deviceGroupId
                permission: $permission
              ) {
                roleDeviceGroup {
                  id
                  permissionFlags
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "roleId": role_id,
            "deviceGroupId": device_group_id,
            "permission": permission,
        }
        _response = await self.execute(
            query=_query,
            operation_name="roleDeviceGroupUpsert",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return RoleDeviceGroupUpsert.model_validate(_data)

    async def role_neops_task(self, **kwargs: Any) -> RoleNeopsTask:
        _query = gql(
            """
            query roleNeopsTask {
              roleNeopsTask {
                results {
                  id
                  role {
                    id
                    name
                  }
                  neopsTask {
                    id
                    name
                  }
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {}
        _response = await self.execute(
            query=_query, operation_name="roleNeopsTask", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return RoleNeopsTask.model_validate(_data)

    async def role_neops_task_upsert(
        self,
        role_id: Union[Optional[str], UnsetType] = UNSET,
        neops_task_id: Union[Optional[str], UnsetType] = UNSET,
        permission: Union[Optional[int], UnsetType] = UNSET,
        **kwargs: Any
    ) -> RoleNeopsTaskUpsert:
        _query = gql(
            """
            mutation roleNeopsTaskUpsert($roleId: ID, $neopsTaskId: ID, $permission: Int) {
              roleNeopsTaskUpsert(
                roleId: $roleId
                neopsTaskId: $neopsTaskId
                permission: $permission
              ) {
                roleNeopsTask {
                  id
                  permissionFlags
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "roleId": role_id,
            "neopsTaskId": neops_task_id,
            "permission": permission,
        }
        _response = await self.execute(
            query=_query,
            operation_name="roleNeopsTaskUpsert",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return RoleNeopsTaskUpsert.model_validate(_data)

    async def role_permission_element(self, **kwargs: Any) -> RolePermissionElement:
        _query = gql(
            """
            query rolePermissionElement {
              rolePermissionElement {
                results {
                  id
                  permissionElement {
                    id
                    name
                    description
                  }
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {}
        _response = await self.execute(
            query=_query,
            operation_name="rolePermissionElement",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return RolePermissionElement.model_validate(_data)

    async def role_permission_element_upsert(
        self,
        role_id: Union[Optional[str], UnsetType] = UNSET,
        permission_element_id: Union[Optional[str], UnsetType] = UNSET,
        permission: Union[Optional[int], UnsetType] = UNSET,
        **kwargs: Any
    ) -> RolePermissionElementUpsert:
        _query = gql(
            """
            mutation rolePermissionElementUpsert($roleId: ID, $permissionElementId: ID, $permission: Int) {
              rolePermissionElementUpsert(
                roleId: $roleId
                permissionElementId: $permissionElementId
                permission: $permission
              ) {
                rolePermissionElement {
                  id
                  permissionFlags
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "roleId": role_id,
            "permissionElementId": permission_element_id,
            "permission": permission,
        }
        _response = await self.execute(
            query=_query,
            operation_name="rolePermissionElementUpsert",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return RolePermissionElementUpsert.model_validate(_data)

    async def role_permission_upsert(
        self,
        id: Union[Optional[str], UnsetType] = UNSET,
        default_permission: Union[Optional[int], UnsetType] = UNSET,
        **kwargs: Any
    ) -> RolePermissionUpsert:
        _query = gql(
            """
            mutation rolePermissionUpsert($id: ID, $defaultPermission: Int) {
              rolePermissionUpsert(id: $id, defaultPermission: $defaultPermission) {
                rolePermission {
                  id
                  defaultPermissionFlags
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "id": id,
            "defaultPermission": default_permission,
        }
        _response = await self.execute(
            query=_query,
            operation_name="rolePermissionUpsert",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return RolePermissionUpsert.model_validate(_data)

    async def role_permissions(self, **kwargs: Any) -> RolePermissions:
        _query = gql(
            """
            query rolePermissions {
              rolePermission {
                results {
                  id
                  name
                  defaultPermission
                  defaultPermissionFlags
                  permissionAllFlags
                  permissionElementPermissionsAll {
                    permissionFlags
                    permissionAllFlags
                    permissionElement {
                      id
                      name
                      description
                    }
                    role {
                      id
                      name
                    }
                  }
                  deviceGroupPermissionsAll {
                    permissionFlags
                    permissionAllFlags
                    role {
                      id
                      name
                    }
                    deviceGroup {
                      id
                      name
                      description
                    }
                  }
                  neopsTaskPermissionsAll {
                    permissionFlags
                    permissionAllFlags
                    role {
                      id
                      name
                    }
                    neopsTask {
                      id
                      name
                      description
                    }
                  }
                  scopePermissionsAll {
                    permissionFlags
                    permissionAllFlags
                    role {
                      id
                      name
                    }
                    scope {
                      id
                      name
                      description
                    }
                  }
                  users {
                    id
                    username
                    lastName
                    firstName
                    email
                  }
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {}
        _response = await self.execute(
            query=_query,
            operation_name="rolePermissions",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return RolePermissions.model_validate(_data)

    async def role_scope_upsert(
        self,
        role_id: Union[Optional[str], UnsetType] = UNSET,
        scope_id: Union[Optional[str], UnsetType] = UNSET,
        permission: Union[Optional[int], UnsetType] = UNSET,
        **kwargs: Any
    ) -> RoleScopeUpsert:
        _query = gql(
            """
            mutation roleScopeUpsert($roleId: ID, $scopeId: ID, $permission: Int) {
              roleScopeUpsert(roleId: $roleId, scopeId: $scopeId, permission: $permission) {
                roleScope {
                  id
                  permissionFlags
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "roleId": role_id,
            "scopeId": scope_id,
            "permission": permission,
        }
        _response = await self.execute(
            query=_query,
            operation_name="roleScopeUpsert",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return RoleScopeUpsert.model_validate(_data)

    async def role_user(self, **kwargs: Any) -> RoleUser:
        _query = gql(
            """
            query roleUser {
              role(myRolesOnly: true) {
                results {
                  id
                  name
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {}
        _response = await self.execute(
            query=_query, operation_name="roleUser", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return RoleUser.model_validate(_data)

    async def rollback(
        self, configuration_id: str, device_id: str, **kwargs: Any
    ) -> Rollback:
        _query = gql(
            """
            mutation rollback($configurationId: ID!, $deviceId: ID!) {
              deviceRollback(configurationId: $configurationId, deviceId: $deviceId) {
                execution {
                  id
                  taskId
                  state
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "configurationId": configuration_id,
            "deviceId": device_id,
        }
        _response = await self.execute(
            query=_query, operation_name="rollback", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return Rollback.model_validate(_data)

    async def saved_search_create(
        self, name: str, description: str, search: str, **kwargs: Any
    ) -> SavedSearchCreate:
        _query = gql(
            """
            mutation savedSearchCreate($name: String!, $description: String!, $search: String!) {
              savedSearchCreate(name: $name, description: $description, search: $search) {
                savedSearch {
                  id
                  name
                  description
                  search
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "name": name,
            "description": description,
            "search": search,
        }
        _response = await self.execute(
            query=_query,
            operation_name="savedSearchCreate",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return SavedSearchCreate.model_validate(_data)

    async def saved_search_delete(self, id: str, **kwargs: Any) -> SavedSearchDelete:
        _query = gql(
            """
            mutation savedSearchDelete($id: ID!) {
              savedSearchDelete(id: $id) {
                savedSearch {
                  id
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {"id": id}
        _response = await self.execute(
            query=_query,
            operation_name="savedSearchDelete",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return SavedSearchDelete.model_validate(_data)

    async def saved_searches(
        self, scope: Union[Optional[Any], UnsetType] = UNSET, **kwargs: Any
    ) -> SavedSearches:
        _query = gql(
            """
            query savedSearches($scope: Decimal) {
              savedSearches(scope: $scope) {
                results {
                  id
                  name
                  description
                  search
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {"scope": scope}
        _response = await self.execute(
            query=_query, operation_name="savedSearches", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return SavedSearches.model_validate(_data)

    async def scope_delete(self, id: str, **kwargs: Any) -> ScopeDelete:
        _query = gql(
            """
            mutation scopeDelete($id: ID!) {
              scopeDelete(id: $id) {
                scope {
                  id
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {"id": id}
        _response = await self.execute(
            query=_query, operation_name="scopeDelete", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return ScopeDelete.model_validate(_data)

    async def scopes_upsert(
        self,
        clientcolumns: Union[Optional[str], UnsetType] = UNSET,
        clientfilter: Union[Optional[str], UnsetType] = UNSET,
        description: Union[Optional[str], UnsetType] = UNSET,
        devicecolumns: Union[Optional[str], UnsetType] = UNSET,
        devicefilter: Union[Optional[str], UnsetType] = UNSET,
        groupcolumns: Union[Optional[str], UnsetType] = UNSET,
        groupfilter: Union[Optional[str], UnsetType] = UNSET,
        id: Union[Optional[str], UnsetType] = UNSET,
        interfacecolumns: Union[Optional[str], UnsetType] = UNSET,
        interfacefilter: Union[Optional[str], UnsetType] = UNSET,
        name: Union[Optional[str], UnsetType] = UNSET,
        show_clients: Union[Optional[bool], UnsetType] = UNSET,
        show_devices: Union[Optional[bool], UnsetType] = UNSET,
        show_groups: Union[Optional[bool], UnsetType] = UNSET,
        show_interfaces: Union[Optional[bool], UnsetType] = UNSET,
        show_topology: Union[Optional[bool], UnsetType] = UNSET,
        tasks: Union[Optional[List[Optional[str]]], UnsetType] = UNSET,
        **kwargs: Any
    ) -> ScopesUpsert:
        _query = gql(
            """
            mutation scopesUpsert($clientcolumns: String, $clientfilter: String, $description: String, $devicecolumns: String, $devicefilter: String, $groupcolumns: String, $groupfilter: String, $id: ID, $interfacecolumns: String, $interfacefilter: String, $name: String, $showClients: Boolean, $showDevices: Boolean, $showGroups: Boolean, $showInterfaces: Boolean, $showTopology: Boolean, $tasks: [ID]) {
              scopesUpsert(
                clientcolumns: $clientcolumns
                clientfilter: $clientfilter
                description: $description
                devicecolumns: $devicecolumns
                devicefilter: $devicefilter
                groupcolumns: $groupcolumns
                groupfilter: $groupfilter
                id: $id
                interfacecolumns: $interfacecolumns
                interfacefilter: $interfacefilter
                name: $name
                showClients: $showClients
                showDevices: $showDevices
                showGroups: $showGroups
                showInterfaces: $showInterfaces
                showTopology: $showTopology
                tasks: $tasks
              ) {
                scope {
                  id
                  name
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "clientcolumns": clientcolumns,
            "clientfilter": clientfilter,
            "description": description,
            "devicecolumns": devicecolumns,
            "devicefilter": devicefilter,
            "groupcolumns": groupcolumns,
            "groupfilter": groupfilter,
            "id": id,
            "interfacecolumns": interfacecolumns,
            "interfacefilter": interfacefilter,
            "name": name,
            "showClients": show_clients,
            "showDevices": show_devices,
            "showGroups": show_groups,
            "showInterfaces": show_interfaces,
            "showTopology": show_topology,
            "tasks": tasks,
        }
        _response = await self.execute(
            query=_query, operation_name="scopesUpsert", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return ScopesUpsert.model_validate(_data)

    async def scopes(
        self, id: Union[Optional[Any], UnsetType] = UNSET, **kwargs: Any
    ) -> Scopes:
        _query = gql(
            """
            query scopes($id: Decimal) {
              scopes(id: $id) {
                results {
                  id
                  name
                  allTasks
                  description
                  groupfilter
                  devicefilter
                  interfacefilter
                  clientfilter
                  groupcolumns
                  devicecolumns
                  interfacecolumns
                  clientcolumns
                  showClients
                  showDevices
                  showGroups
                  locationDrillDownAttributeSchema
                  showInterfaces
                  showTopology
                  dashboardConfiguration
                  tasks {
                    id
                    name
                    isCheck
                    isTask
                  }
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {"id": id}
        _response = await self.execute(
            query=_query, operation_name="scopes", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return Scopes.model_validate(_data)

    async def single_discovery(
        self,
        execute_on: Union[Optional[List[Optional[str]]], UnsetType] = UNSET,
        **kwargs: Any
    ) -> SingleDiscovery:
        _query = gql(
            """
            mutation singleDiscovery($executeOn: [ID]) {
              discovery(
                executeOn: $executeOn
                executeOnAll: false
                includeInterfaces: true
                recursive: false
              ) {
                execution {
                  id
                  taskId
                  state
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {"executeOn": execute_on}
        _response = await self.execute(
            query=_query,
            operation_name="singleDiscovery",
            variables=_variables,
            **kwargs
        )
        _data = self.get_data(_response)
        return SingleDiscovery.model_validate(_data)

    async def json_form(
        self,
        execute_on: Union[Optional[List[Optional[str]]], UnsetType] = UNSET,
        execute_on_type: Union[Optional[RunOnEnum], UnsetType] = UNSET,
        neops_task_id: Union[Optional[str], UnsetType] = UNSET,
        output_schema_type: Union[Optional[OutputSchemaTypeEnum], UnsetType] = UNSET,
        provider_full_qualified_name: Union[Optional[str], UnsetType] = UNSET,
        provider_schema: Union[Optional[ProviderSchemaEnum], UnsetType] = UNSET,
        resolve_all_elements: Union[Optional[bool], UnsetType] = UNSET,
        schema: Union[Optional[Any], UnsetType] = UNSET,
        search_query: Union[Optional[str], UnsetType] = UNSET,
        task_arguments: Union[Optional[Any], UnsetType] = UNSET,
        uniquetaskname: Union[Optional[str], UnsetType] = UNSET,
        scope: Union[Optional[int], UnsetType] = UNSET,
        **kwargs: Any
    ) -> JsonForm:
        _query = gql(
            """
            mutation jsonForm($executeOn: [ID], $executeOnType: RunOnEnum, $neopsTaskId: ID, $outputSchemaType: OutputSchemaTypeEnum, $providerFullQualifiedName: String, $providerSchema: ProviderSchemaEnum, $resolveAllElements: Boolean, $schema: JSONString, $searchQuery: String, $taskArguments: JSONString, $uniquetaskname: String, $scope: Int) {
              jsonForm(
                executeOn: $executeOn
                executeOnType: $executeOnType
                neopsTaskId: $neopsTaskId
                outputSchemaType: $outputSchemaType
                providerFullQualifiedName: $providerFullQualifiedName
                providerSchema: $providerSchema
                resolveAllElements: $resolveAllElements
                schema: $schema
                searchQuery: $searchQuery
                taskArguments: $taskArguments
                uniquetaskname: $uniquetaskname
                scope: $scope
              ) {
                jsonSchema
                data
                uiSchema
                baseSchema
                runOn
                devices {
                  id
                  hostname
                }
                groups {
                  id
                  name
                }
                interfaces {
                  id
                  name
                  device {
                    id
                    hostname
                  }
                }
                clients {
                  id
                  macaddress
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "executeOn": execute_on,
            "executeOnType": execute_on_type,
            "neopsTaskId": neops_task_id,
            "outputSchemaType": output_schema_type,
            "providerFullQualifiedName": provider_full_qualified_name,
            "providerSchema": provider_schema,
            "resolveAllElements": resolve_all_elements,
            "schema": schema,
            "searchQuery": search_query,
            "taskArguments": task_arguments,
            "uniquetaskname": uniquetaskname,
            "scope": scope,
        }
        _response = await self.execute(
            query=_query, operation_name="jsonForm", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return JsonForm.model_validate(_data)

    async def topology(
        self,
        query: Union[Optional[str], UnsetType] = UNSET,
        limit: Union[Optional[int], UnsetType] = UNSET,
        query_type_global: Union[Optional[bool], UnsetType] = UNSET,
        **kwargs: Any
    ) -> Topology:
        _query = gql(
            """
            query topology($query: String, $limit: Int, $queryTypeGlobal: Boolean = true) {
              topology(query: $query, limit: $limit, queryTypeGlobal: $queryTypeGlobal) {
                type
                metric
                version
                protocol
                nodes {
                  id
                  label
                  properties {
                    device {
                      id
                      hostname
                      ip
                    }
                  }
                }
                links {
                  source
                  target
                  cost
                  properties {
                    sourceInterface {
                      id
                      name
                      state
                    }
                    targetInterface {
                      id
                      name
                      state
                    }
                  }
                }
              }
            }
            """
        )
        _variables: Dict[str, object] = {
            "query": query,
            "limit": limit,
            "queryTypeGlobal": query_type_global,
        }
        _response = await self.execute(
            query=_query, operation_name="topology", variables=_variables, **kwargs
        )
        _data = self.get_data(_response)
        return Topology.model_validate(_data)
